#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*function declarations*/
unsigned short shortswap(unsigned short w);
unsigned long filesize(FILE *in);
unsigned long compress(FILE *source, FILE *out,unsigned long tempy, unsigned long source_size);
unsigned long chewy(unsigned char *search,unsigned long searchx,unsigned char *table,unsigned long tablex);

/*open files and set them up*/
int main(int argc, char *argv[])
{char filename[130],y;
FILE *in, *out, *tempy;
unsigned long x;
unsigned short z;

    if(argc>1) strcpy(filename,argv[1]);
while (!(in = fopen(filename, "rb"))) {
	printf("\nCompress what file? ");
	strcpy(filename,"\0");	
	gets(filename);
    }

/*well, had to add 0xFEE 00's anyway
make a temp file, and copy the original to it
this will be the main sample to work with*/
if(!(tempy=tmpfile()))
    {fprintf(stderr,"\n\bcouldn't open a bloody temp file\nseriously...");
    system("PAUSE");
    exit(1);}    
/*in theory, filesize() doesn't tamper with file position*/
for(x=0;x<0xFEE;x++) fputc(0,tempy);
for(x=0;x<filesize(in);x++) fputc(fgetc(in),tempy);
fclose(in);


/*open and set up output file
make room for four long offsets at beginning of file*/
    strcat(filename, ".cmp");
    if(argc>2) strcpy(filename,argv[2]);
while (!(out = fopen(filename, "wb+"))) {
	printf("\nWhere did you want it again? ");
	strcpy(filename,"\0");	
	gets(filename);
    }
/*the first two pointers get overwritten later, so just send something that size*/
z=x/8;
z=shortswap(z);
fwrite(&z,2,1,out);
x=0;
fwrite(&x,2,1,out);
fwrite(&x,4,1,out); /*out @ 0x8*/

printf("\nCompressing.\nThis will take a while due to some crappy code...\n");
/*now to actually do some compression*/
printf("\n%X of %X bytes compressed",compress(tempy,out,0xfee,x)-0xfee,filesize(tempy)-0xFEE);

  

/*mop up
here the offsets are added to the output file
at +4, set the size of data, which is the filesize -0xC (data length)
then, extend to word and set the total file size to 0x0
this is included here as the compression is also used with different formats*/
z=filesize(out)/8;
z=shortswap(z);
fseek(out,2,SEEK_SET);
fwrite(&z,2,1,out);

/*word extend*/
fseek(out,-1,SEEK_END);
y=fgetc(out);
fseek(out,0,SEEK_END);
while(filesize(out)%4) fputc(y,out);


  fclose(out);
  fclose(tempy);
  printf("\n\nRoswell that ends well.  Have a nice day ;*)\n");
  /*getchar();*/
  return 0;
}

/*************************************
basic idea behind the compression scheme
(note: this is slow and crappy)
There are three buffers:
    search string, null terminated
    alias buffer -which is really just a subset of the output- 
        allocated and null terminated
    packet of data to be output in file, containing:
        bitflag byte stating which are alias bytes
        the bytes themselves, either 1-byte literals or 2-byte aliases (8-16 total)

strstr() is used to search the alias buffer for the search string.
the search string is initially 18 bytes long (3bytes + 15 max),
 and the alias buffer also contains the string-1 char in the case of "replication".
If a hit is not found, both buffers are shortened with NULLs and retested.
 If it is not found with a 3-byte search string,
 the single byte is stored and the corresponding bitflag toggled
  format in output will look like: aa #A, where Aaa is an address, #+3=bytes
  so, let that intel processor byteswap for you by using an int!

In the case of a hit, first the series is retested ot get the last possible hit.
 This provides compression 100% equivalent to the original source.
 The position to the hit is determined and
 added to the alias file offset to determine it's file location.
That value is masked to produce a three-nibble offset.
The bytes are swapped, then the length of the search string -3
 is stored in the last nibble.

As you can tell, the more redundancy within the file, the faster it compresses.
Pretty much any halfwit can come up with a better scheme & implementation.
I'm a hacker, not a coder...

oh yeah...
returns 1 if an error, or 0 if all is well.
*source is your input file (tempy, already extended by 0xFEE)
*out is your outut

source_init is original position in source
out_init is original position in out
index is the current position-0x1000
current is the byte sequence you are testing (in CR starts at 0xFEE)
size is the size of the block during allocation

*alias points to the allocated block of test values
search is your search string, up to 18 char long + NULL
bitflag stores your nifty bitflag data
    bitflag is 0 if a couplet, 1 if a normal byte
    shift left after each iteration (lead = lead << 1;)
*hit and *nexthit point to the results of strstr

values[] stores the eight values
*************************************/

unsigned long compress(FILE *source, FILE *out, unsigned long current,unsigned long source_size)
{unsigned long searchx,size,hit,y;
unsigned char *alias, search[18], bitflag,value[16];
unsigned short x,valuex;

if(!(alias = (unsigned char *) malloc(0x1012)))
    {fprintf(stderr,"\nhorrible memory allocation problem\naborting....");
     system("PAUSE");
     exit(1);
     }    


/*lupus*/
while(current<filesize(source))
{
    
valuex=0;
bitflag=0;  /*reset flag.  add 1 if set, then advance with leftshift*/
for(x=0;x<8;x++)    /*do this 8 times - one for each value*/
    {bitflag = bitflag >> 1; /*advance to next flag*/
    /*grab search string.
    it should return # actually read, so use that to determine allocation size*/
    fseek(source,current,SEEK_SET);
    if((searchx=fread(search,1,18,source))>0)/*if done reading, loop until finished*/
    {
     /*set size for allocated block 0xFFF + #read.  if current<0x1000, use current.
     realloc with a NULL pointer should act like malloc*/
     if(current<0x1000) size=current;
     else size=0xFFF;
     fseek(source,current-size,SEEK_SET);
     if(!((unsigned char *) realloc(alias,size+searchx-1)))
          {fprintf(stderr,"\nhorrible memory allocation problem\naborting....");
          system("PAUSE");
          exit(1);
          }    
     /*copy data into block*/
     fread(alias,1,size+searchx-1,source);
     
     /*actual search: repeat until a hit found or string is 2char*/
     while(searchx>2)
          {if((hit=chewy(search,searchx,alias,size))<0x8000) break;
          /*otherwise, try a smaller string*/
          searchx--;
          }
     /*new search method, should be less stupid*/
          
     if(searchx>2)   /*if string found though, get latest possible string*/
          {/*while (strstr(hit,search)!=NULL) hit=strstr(hit,search);*/
          /*don't need *size* anymore this run - set as file offset*/
          size=current-size+hit;
          value[valuex]= (size & 0xFF);
          size=size >> 4;
          value[valuex+1]= (char)((size & 0xF0) + (searchx-3));
          current+=searchx;
          valuex+=2;
          }
     else  {bitflag+= 0x80;          /*if hit NULL (never found)*/
          fseek(source,current,SEEK_SET);
          value[valuex]=fgetc(source);
          current++;
          valuex++;
          }     
     }   /*end of values left>0 check*/
   }/*end for(valuex=0;valuex<8;valuex++)*/

/*now that the whole value is assembled, write to out*/
fputc(bitflag,out);
for(x=0;x<valuex;x++) fputc(value[x],out);

}   /*lupus*/

/*Roswell that ends well*/
free(alias);
return current;}    

/*****************************************
weird string check function
entirely because nothing else was working
*****************************************/
unsigned long chewy(unsigned char *search,unsigned long searchx,unsigned char *table,unsigned long tablex)
{unsigned long x,locate;
unsigned char compare[18];

for(locate=0;locate<tablex;locate++)
    {for(x=0;x<searchx;x++) compare[x]=table[x+locate];
    

    for(x=0;x<searchx;x++)
        {
        if(search[x]!=compare[x]) break;
        }
    if(x==searchx) return locate;
    }    
return 0x8000;}

/*standard 16bit byteswapping*/
unsigned short int shortswap(unsigned short int w)
{return (w >> 8) | (w << 8);
}
/****************************************/
/*get the size of a file
it happens often enough it might as well be a function
plus, it won't mess with CUR_POS*/
/****************************************/
unsigned long filesize(FILE *in)
{unsigned long cur,end;
cur=ftell(in);
fseek(in,0,SEEK_END);
end=ftell(in);
fseek(in,cur,SEEK_SET);
return end;}

