#include <stdio.h>
#include <stdlib.h>

#define PAGE_OFFSET 0x00000FEE   /*this is the size the compression dohick is padded to*/
/*#define DEBUGGERY           /*saves swap file for debugging*/

/*standard 16bit byteswapping*/
unsigned short int shortswap(unsigned short int w)
{return (w >> 8) | (w << 8);
}

int Rend(FILE *olde,FILE *newe,unsigned long pos,unsigned long csize,unsigned long dsize);
int Suck(FILE *olde,FILE *swap);

/**main loop**/
int main(int argc, char *argv[])
{char filename[130];
unsigned short x,y;
FILE *olde;
FILE *newe;

  /*open file, then hack name and spit open new*/
  if(argc>1) strcpy(filename,argv[1]);
  while((olde = fopen(filename,"rb"))==NULL)
        {printf("\nFile to open: ", filename);
        strcpy(filename,"\0");
        gets(filename);}

        strcat(filename, ".dec");
  while((newe = fopen(filename,"wb+"))==NULL)
        {printf("\ncouldn't open %s\nName output file: ", filename);
        strcpy(filename,"\0");
        gets(filename);}
  
  fread(&y,2,1,olde);
  fread(&x,2,1,olde);
  x=shortswap(x);
  y=shortswap(y);
  x=Rend(olde,newe,8,(unsigned long)x*8,(unsigned long)y*8);
  fclose(olde);
  fclose(newe);
    
  if(x) 
    {fprintf(stderr,"\nFailure to pull file.\nAborting...");
    remove(filename);
    }
  
  return 0;
}

/**basic ripping**/
int Rend(FILE *olde,FILE *newe,unsigned long pos,unsigned long csize,unsigned long dsize){
unsigned long x,addies[3];
unsigned char lead, trick;
FILE *swap;

#ifdef DEBUGGERY
char filename[20];

        strcpy(filename,"swapfile.bin");
  while((swap = fopen(filename,"wb+"))==NULL)
        {printf("\ncouldn't open %s\nSwap file: ", filename);
        strcpy(filename,"\0");
        gets(filename);}  
#else  
  if(!(swap=tmpfile()))
    {fprintf(stderr,"\nCould not open a temporary file.\nAborting...");
    return 1;
    }
#endif

/*add 0xFEE bytes to -swap-*/
for(x=0;x<PAGE_OFFSET;x++) fputc(0,swap);

fseek(olde,pos,SEEK_SET);

while(ftell(olde)<csize)
    {/*test a premature EOF*/
     if(x>dsize)
        {
#ifdef DEBUGGERY
         fclose(swap);
#endif
         return 1;
         }
    /*decompression*/
    lead=fgetc(olde);
    for(x=0;x<8;x++)
            {if(lead & 1)
               {trick = fgetc(olde);
               fputc(trick,swap);}
            else Suck(olde,swap);
            lead = lead >> 1;
            }
      fseek(swap,0,SEEK_END);
      x=ftell(swap)-PAGE_OFFSET;
    }    

/*copy and truncate file from -swap- to -newe-*/
fseek(swap,PAGE_OFFSET,SEEK_SET);
for(x=0;x<dsize;x++) fputc(fgetc(swap),newe);

fclose(swap);
return 0;}

/**pulls couplets and handles aliasing**/
int Suck(FILE *olde,FILE *swap){
unsigned int addy,y;
unsigned long range;
unsigned char buffer;
 /*character aliasing*/
 /*
 Memory is aliased in Ya-0 derivative compressions
 When the lead bit = 0, it reads in two characters which determine the address and # characters copied
 The alias follows the format aa #A, where Aaa is the address offset and #+3 characters read
 These are copied one byte at a time, so replicating the last written character is possible
 The address is also incremented in 0x1000's using the current file position
 If the combined address value is larger than the current filesize, though, it will subtract the value instead
 
 In this implementation, the file is decompressed into a buffer, so the actual file starts at 0xFEE
 */
 addy=fgetc(olde);
 range=fgetc(olde);
 addy=addy+((range/0x10)*0x100);
 range&=0xF;
 range+=3;
 addy+=(ftell(swap)&0xFFFFF000);
 if(addy>ftell(swap)) addy-=0x1000;
 
 /*read in one at a time (supports duplication this way)*/
 for(y=0;y<range;y++)
  {fseek(swap,addy+y,SEEK_SET);
     buffer = fgetc(swap);
     fseek(swap,0,SEEK_END);
     fputc(buffer,swap);
  }    
    return 0;}
